%{
#include <stdio.h>
#include <string.h>
char gWindowToCreate[1024]="";
char widgetLevel=0;
char gFluidConstant[1024]="";
char gCurrentMenubar[1024]="";
char gMenuDirectory[1024]="";
char gMenuLevel=0;
char gMenuItemName[1024]="nil";
char gMenuItemCallback[1024]="nil";
char gMenuItemUserdata[1024]="nil";
char gMenuItemType=0;
unsigned int gMenuItemShortcut=0;

void ResetMenuItemSettings()
{
	sprintf(gMenuItemName, "Item");
	sprintf(gMenuItemCallback, "nil");
	sprintf(gMenuItemUserdata, "nil");
	gMenuItemType=0;
	gMenuItemShortcut=0;
}

int FluidConstantToNumber(char *str)
{
	if (!strcmp(str, "Normal")){return 0;}
	if (!strcmp(str, "Vertical")){return 0;}
	if (!strcmp(str, "Dot")){return 0;}
	if (!strcmp(str, "Integer")){return 0;}
	if (!strcmp(str, "normal")){return 0;}
	if (!strcmp(str, "No_Select")){return 0;}
	if (!strcmp(str, "BOTH")){return 0;}
	if (!strcmp(str, "Toggle")){return 1;}
	if (!strcmp(str, "Horizontal")){return 1;}
	if (!strcmp(str, "Simple")){return 1;}
	if (!strcmp(str, "Line")){return 1;}
	if (!strcmp(str, "Float")){return 1;}
	if (!strcmp(str, "popup1")){return 1;}
	if (!strcmp(str, "Select")){return 1;}
	if (!strcmp(str, "HORIZONTAL")){return 1;}
	if (!strcmp(str, "Vert_Fill")){return 2;}
	if (!strcmp(str, "Fill")){return 2;}
	if (!strcmp(str, "Int")){return 2;}
	if (!strcmp(str, "popup2")){return 2;}
	if (!strcmp(str, "Hold")){return 2;}
	if (!strcmp(str, "VERTICAL")){return 2;}
	if (!strcmp(str, "Horz_Fill")){return 3;}
	if (!strcmp(str, "popup3")){return 3;}
	if (!strcmp(str, "Multi")){return 3;}
	if (!strcmp(str, "Vert_Knob")){return 4;}
	if (!strcmp(str, "Multiline")){return 4;}
	if (!strcmp(str, "popup12")){return 4;}
	if (!strcmp(str, "Horz_Knob")){return 5;}
	if (!strcmp(str, "Secret")){return 5;}
	if (!strcmp(str, "popup23")){return 5;}
	if (!strcmp(str, "HORIZONTAL_ALWAYS")){return 5;}
	if (!strcmp(str, "popup13")){return 6;}
	if (!strcmp(str, "VERTICAL_ALWAYS")){return 6;}
	if (!strcmp(str, "popup123")){return 7;}
	if (!strcmp(str, "BOTH_ALWAYS")){return 7;}
	if (!strcmp(str, "Radio")){return 102;}
	
	return -1;
}

int FluidMenuConstantToNumber(char *str)
{
	if (!strcmp(str, "Toggle")){return 2;}
	if (!strcmp(str, "Radio")){return 8;}
	
	return 0;
}

char *LevelUp(char *str)
{
	int i;
	for (i=strlen(str)-1; i>=0; i--)
	{
		if (str[i]=='/'){str[i]='\0';break;}
		str[i]='\0';
	}
}
%}
%token COMMENT VERSION HEADER_NAME CODE_NAME FUNCTION IDENTIFIER LBRA RBRA RCUR LCUR OPEN CODE SELECTED ANYTHING NON_CURLY INTEGER TYPE VISIBLE XYWH LABEL CALLBACKF LABELSIZE TEXTSIZE ALIGN FLOATR MAXIMUM MINIMUM STEP VALUE BOX DOWN_BOX WHEN RESIZABLE SIZE_RANGE TEXTFONT TOOLTIP CODE0 COLOR LABELCOLOR LABELTYPE SELECTION_COLOR TEXTCOLOR LABELFONT IMAGEATTR FL_WINDOW FL_BUTTON FL_INPUT FL_VALUE_INPUT FL_BROWSER FL_CHECK_BUTTON FL_TEXT_DISPLAY FL_OUTPUT FL_GROUP FL_MENU_BAR SUBMENU MENUITEM USERDATA SHORTCUT POSHEX
%%
start	:	COMMENT VERSION HEADER_NAME CODE_NAME function
			;
function : FUNCTION LCUR {fprintf(gParserOutput, "--function ");} IDENTIFIER {fprintf(gParserOutput, yytext);} LBRA RBRA {fprintf(gParserOutput, "()\n");} RCUR LCUR attriblist RCUR LCUR blocklist RCUR {fprintf(gParserOutput, "\n--end\n");}
	;

blocklist	: block {fprintf(gParserOutput, "\n");} blocklist | block;

block	: CODE LCUR non_curly RCUR LCUR attriblist RCUR
		| {ignoreType=0;widgetType[0]='\0';} widget {if (widgetType[0]=='\0'){sprintf(widgetType, yytext);}} name_or_empty {fprintf(gParserOutput, "do %s= fltk:%s(0,0,0,0,\"\")\n", widgetIdentifier, widgetType);if (!strcmp(widgetType, "Fl_Double_Window")){sprintf(gWindowToCreate, widgetIdentifier);}widgetLevel++;} LCUR attriblist RCUR subwidgetlist {widgetLevel--;fprintf(gParserOutput, "end\n");if ( (gWindowToCreate[0]!='\0') && (widgetLevel==0) ){fprintf(gParserOutput, "%s:show()\n", gWindowToCreate);gWindowToCreate[0]='\0';}}
		
		| {ignoreType=0;widgetType[0]='\0';} FL_MENU_BAR {if (widgetType[0]=='\0'){sprintf(widgetType, yytext);}} name_or_empty {fprintf(gParserOutput, "do %s= fltk:%s(0,0,0,0,\"\")\nmenudir0=\"\"\n", widgetIdentifier, widgetType);sprintf(gCurrentMenubar, widgetIdentifier);} LCUR attriblist RCUR  submenulist {fprintf(gParserOutput, "Fl_Group:current(Fl_Group:current():parent())\nend\n");}
		
		| {ignoreType=0;widgetType[0]='\0';} FL_GROUP {if (widgetType[0]=='\0'){sprintf(widgetType, yytext);}} name_or_empty {fprintf(gParserOutput, "do %s= fltk:%s(0,0,0,0,\"\")\n", widgetIdentifier, widgetType);} LCUR attriblist RCUR subwidgetlist {fprintf(gParserOutput, "Fl_Group:current(Fl_Group:current():parent())\nend\n");}
		;

number : FLOATR | INTEGER;

subwidgetlist: LCUR RCUR | LCUR blocklist RCUR |  ;

submenulist: LCUR RCUR | LCUR submenusOrItems RCUR | ;

submenusOrItems: menuitem submenusOrItems | submenu submenusOrItems | submenu | menuitem;

submenu: {gMenuLevel++;} SUBMENU name_or_empty LCUR attriblist3 RCUR submenulist {gMenuLevel--;};

menuitem: MENUITEM name_or_empty LCUR {ResetMenuItemSettings();} attriblist2 RCUR {fprintf(gParserOutput, "%s:add(%s,%d,%s,%s,%d)\n", gCurrentMenubar, gMenuItemName, gMenuItemShortcut, gMenuItemCallback, gMenuItemUserdata, gMenuItemType);};

widget	:	FL_WINDOW {ignoreType=1;sprintf(widgetType, "Fl_Double_Window");} | FL_BUTTON | FL_INPUT | FL_VALUE_INPUT | FL_BROWSER | FL_CHECK_BUTTON | FL_TEXT_DISPLAY | FL_OUTPUT | IDENTIFIER ;
		
attriblist2 : {/*fprintf(gParserOutput, "--");*/} attrib2 attriblist2 | LABEL {sprintf(gMenuItemName, "itemname");fprintf(gParserOutput, "itemname=menudir%d..\"", gMenuLevel);} name_or_empty_three {fprintf(gParserOutput, "\"\n");} attriblist2
		| CALLBACKF {sprintf(gMenuItemCallback, "itemcallback");fprintf(gParserOutput, "itemcallback=");} name_or_empty_three {fprintf(gParserOutput, "\n");} attriblist2 
		| USERDATA {sprintf(gMenuItemUserdata, "itemuserdata");fprintf(gParserOutput, "itemuserdata=\"");} name_or_empty_three {fprintf(gParserOutput, "\"\n");} attriblist2 
		| SHORTCUT POSHEX {gMenuItemShortcut=atoi(yytext);} attriblist2
		| TYPE IDENTIFIER {gMenuItemType= FluidMenuConstantToNumber(yytext);} attriblist2
		| XYWH LCUR INTEGER INTEGER INTEGER INTEGER RCUR attriblist2 |
 ;

attriblist3 : {/*fprintf(gParserOutput, "--");*/} attrib2 attriblist3 | LABEL {fprintf(gParserOutput, "menudir%d=menudir%d..\"", gMenuLevel, gMenuLevel-1);} name_or_empty_three {fprintf(gParserOutput, "/\"\n");} attriblist3 
		| XYWH LCUR INTEGER INTEGER INTEGER INTEGER RCUR attriblist3
		| TYPE IDENTIFIER attriblist3 | ;



attrib2			: OPEN | SELECTED | visible | maximum | minimum | step | value | box | down_box | labelsize | textsize | align | when | resizable | size_range | textfont | tooltip | code0 | color | labelcolor | labeltype | textcolor | selection_color | labelfont | imageattr | IDENTIFIER {fprintf(gParserOutput, "--unknown attribute: %s\n", yytext);} ;	

attriblist	: attrib attriblist |  ;

attrib			: OPEN | SELECTED | xywh | type | visible | label | callbackf | maximum | minimum | step | value | box | down_box | labelsize | textsize | align | when | resizable | size_range | textfont | tooltip | code0 | color | labelcolor | labeltype | textcolor | selection_color | labelfont | imageattr | IDENTIFIER {fprintf(gParserOutput, "--unknown attribute: %s\n", yytext);} ;

name_or_empty	: IDENTIFIER {sprintf(widgetIdentifier, yytext);} | LCUR RCUR {sprintf(widgetIdentifier, "widget");};

name_or_empty_three	: non_curly RCUR;


type	: TYPE LCUR IDENTIFIER {if (!ignoreType){sprintf(gFluidConstant, "%s_", yytext); fprintf(gParserOutput, "%s:type(", widgetIdentifier);}} IDENTIFIER {if (!ignoreType){strcat(gFluidConstant, yytext);fprintf(gParserOutput, "%d)\n", FluidConstantToNumber(gFluidConstant));}} RCUR | TYPE IDENTIFIER {if (!ignoreType){fprintf(gParserOutput, "%s:type(%d)\n", widgetIdentifier, FluidConstantToNumber(yytext));}} ;

label	: LABEL {fprintf(gParserOutput, "%s:label(\"", widgetIdentifier);} name_or_empty_three {fprintf(gParserOutput, "\")\n");}

tooltip	: TOOLTIP {fprintf(gParserOutput, "%s:tooltip(\"", widgetIdentifier);} name_or_empty_three {fprintf(gParserOutput, "\")\n");}

callbackf	: CALLBACKF {fprintf(gParserOutput, "%s:callback(", widgetIdentifier);} name_or_empty_three {fprintf(gParserOutput, ")\n");}

xywh		: XYWH LCUR INTEGER {rectx=atoi(yytext);} INTEGER {recty=atoi(yytext);} INTEGER {recth=atoi(yytext);} INTEGER {rectw=atoi(yytext);} RCUR {fprintf(gParserOutput, "%s:resize(%d,%d,%d,%d)\n", widgetIdentifier, rectx,recty,recth,rectw);}

minimum	:	MINIMUM number {fprintf(gParserOutput, "%s:minimum(%s)\n", widgetIdentifier, yytext);} ;

maximum	:	MAXIMUM number {fprintf(gParserOutput, "%s:maximum(%s)\n", widgetIdentifier, yytext);} ;

step	:	STEP number {fprintf(gParserOutput, "%s:step(%s)\n", widgetIdentifier, yytext);} ;

value	:	VALUE number {fprintf(gParserOutput, "%s:value(%s)\n", widgetIdentifier, yytext);} ;

textsize: TEXTSIZE INTEGER {fprintf(gParserOutput, "%s:textsize(%s)\n", widgetIdentifier, yytext);} ;

labelsize: LABELSIZE INTEGER {fprintf(gParserOutput, "%s:labelsize(%s)\n", widgetIdentifier, yytext);} ;

align: ALIGN INTEGER {fprintf(gParserOutput, "%s:align(%s)\n", widgetIdentifier, yytext);} ;

visible: VISIBLE {fprintf(gParserOutput, "--%s:show()\n", widgetIdentifier);} ;

when: WHEN INTEGER {fprintf(gParserOutput, "%s:when(%s)\n", widgetIdentifier, yytext);} ;

resizable: RESIZABLE {fprintf(gParserOutput, "Fl_Group:current():resizable(%s)\n", widgetIdentifier);} ;

size_range		: SIZE_RANGE LCUR INTEGER {rectx=atoi(yytext);} INTEGER {recty=atoi(yytext);} INTEGER {recth=atoi(yytext);} INTEGER {rectw=atoi(yytext);} RCUR {fprintf(gParserOutput, "%s:size_range(%d,%d,%d,%d)\n", widgetIdentifier, rectx,recty,recth,rectw);}

textfont: TEXTFONT INTEGER {fprintf(gParserOutput, "%s:textfont(%s)\n", widgetIdentifier, yytext);} ;

labelfont: LABELFONT INTEGER {fprintf(gParserOutput, "%s:labelfont(%s)\n", widgetIdentifier, yytext);} ;

code0	: CODE0 name_or_empty_three {fprintf(gParserOutput, "\n");}

imageattr : IMAGEATTR {fprintf(gParserOutput, "fltk.fl_register_images()\nlocal img = Fl_Shared_Image.get(\"");}name_or_empty_three {fprintf(gParserOutput, "\")\n%s:image(img)\n%s:redraw()\n", widgetIdentifier, widgetIdentifier);}

color:	COLOR INTEGER {fprintf(gParserOutput, "%s:color(%s)\n", widgetIdentifier, yytext);} ;

labelcolor:	LABELCOLOR INTEGER {fprintf(gParserOutput, "%s:labelcolor(%s)\n", widgetIdentifier, yytext);} ;

selection_color:	SELECTION_COLOR INTEGER {fprintf(gParserOutput, "%s:selection_color(%s)\n", widgetIdentifier, yytext);} ;

textcolor:	TEXTCOLOR INTEGER {fprintf(gParserOutput, "%s:textcolor(%s)\n", widgetIdentifier, yytext);} ;

			
non_curly	: NON_CURLY | NON_CURLY non_curly;

down_box	: DOWN_BOX IDENTIFIER {fprintf(gParserOutput, "%s:down_box(fltk.FL_%s)\n", widgetIdentifier, yytext);} ;

box	: BOX IDENTIFIER {fprintf(gParserOutput, "%s:box(fltk.FL_%s)\n", widgetIdentifier, yytext);} ;

labeltype	: LABELTYPE IDENTIFIER {fprintf(gParserOutput, "%s:labeltype(fltk.FL_%s)\n", widgetIdentifier, yytext);} ;
%%

